:- import new_trie/1 , trie_intern/2, trie_interned/4, trie_interned/2,  trie_unintern_nr/2,
	  trie_unintern/2, delete_trie/1, bulk_trie_intern/2,trie_retractall/2  from intern.
:- import xsb_error_get_tag/2 from error_handler.

:- set_prolog_flag(max_table_answer_depth,10).
:- set_prolog_flag(max_table_answer_list_depth,10).

test:- set_prolog_flag(unify_with_occurs_check,off),fail.
test:- create_trie,fail.
test:- test_term_error,fail.
test:- test_list_error,fail.
test:- set_prolog_flag(max_table_answer_action,failure),
       set_prolog_flag(max_table_answer_list_action,failure),fail.
test:- test_term_failure,writeln(test_term_failure_success),fail.
test:- test_list_error,writeln(test_list_failure_success),fail.
test.

create_trie:- new_trie(Trie),assert(cycle_trie(Trie)).

test_term_error:- cycle_trie(Trie),
       X = f(X),
       catch(trie_intern(X,Trie),E,(xsb_error_get_tag(E,table_error),writeln(caught_term_error))).
test_list_error:- 
       cycle_trie(Trie),
       X = [X],
       catch(trie_intern(X,Trie),E,(xsb_error_get_tag(E,table_error),writeln(caught_list_error))).

test_term_failure:- cycle_trie(Trie),
       X = f(X),
       trie_intern(X,Trie).
test_list_failure:- 
       cycle_trie(Trie),
       X = [X],
       trie_intern(X,Trie).

